from typing import TYPE_CHECKING
from lazy_imports import LazyImporter
import sys

_import_structure = {
    "Ratelimit": ["RateLimit"],
    "Redis": ["Redis", "redisQueue", "redisQueueConfirm"],
    "ProgressBar": ["ProgressBar"],
    "Telegram": ["Telegram", "TelegramPeer"],
    "Lock": ["Lock"],
    "Database": ["Database"],
    "Prometheus": ['Prometheus'],
    "Selenium": ["Selenium"],
    "URL": ["URL"],
    "Ratelimit": ["RateLimit"],
    "Chan": ["Chan"],
    "WebServer": ["WebServer"],
    "TelegramBotOfficial": ["TelegramBotOfficial"],
    "TelegramBot": ["TelegramBot"],
    "CSV": ["CSV"],
    "Argparser": ["Argparser"],
    "Elasticsearch": ["Elasticsearch"],
    "Crontab": ["Crontab"],
    "WaitGroup": ["WaitGroup"],
    # from . import Xlsx
    "Xlsx": ["Xlsx"],
    "XPath": ["XPath"],
    # from . import Translater
    "Translater": ["Translater"],
    "SSH": ["SSH"],
    "Github": ["Github"],
    "Kafka": ["Kafka", "kafkaProducer", "kafkaConsumer"],
    "Queue": ["Queue"],
    # from . import RSS
    "RSS": ["RSS"],
    "MatrixBot": ["MatrixBot"],
    "Nslookup": ["Nslookup"],
    # from . import Twitter
    "Twitter": ["Twitter"],
    "DistributedLock": ["DistributedLock"],
    # from . import BlockChain
    "BlockChain": ["BlockChain"], 
    "JavaScript": ["JavaScript"],
    # from . import ComputerVision
    "ComputerVision": ["ComputerVision"],
    "WebCrawler": ["WebCrawler"],
    "OCR": ["OCR"],
}

if TYPE_CHECKING:
    from .Redis import Redis, redisQueue, redisQueueConfirm
    from .Database import Database
    from .ProgressBar import ProgressBar
    from .Telegram import Telegram, TelegramPeer
    from .Prometheus import Prometheus
    from .CSV import CSV
    from .Selenium import Selenium
    from .Lock import Lock
    from . import Prometheus
    from .URL import URL
    from .Ratelimit import RateLimit
    from .Chan import Chan
    from .WebServer import WebServer
    from .TelegramBotOfficial import TelegramBotOfficial
    from .TelegramBot import TelegramBot
    from . import CSV
    from .Argparser import Argparser
    from .Elasticsearch import Elasticsearch
    from .Crontab import Crontab
    from .WaitGroup import WaitGroup
    from .Xlsx import Xlsx
    from .XPath import XPath
    from .Translater import Translater
    from .SSH import SSH
    # from .TelegramAsync import TelegramAsync
    from .Github import Github
    from .Kafka import Kafka, kafkaProducer, kafkaConsumer
    from .Queue import Queue
    from .RSS import RSS
    from .MatrixBot import MatrixBot
    from .Nslookup import Nslookup
    from .Twitter import Twitter
    from .DistributedLock import DistributedLock
    # from .Test import Test
    from .BlockChain import BlockChain
    from .JavaScript import JavaScript
    from .ComputerVision import ComputerVision
    from .WebCrawler import WebCrawler
    from .OCR import OCR
else:
    sys.modules[__name__] = LazyImporter(
        __name__,
        globals()["__file__"],
        _import_structure,
        extra_objects={},
    )


